// =============================================================
//		Crystal-control - javascript code
// 			
// =============================================================
// 		conception et
// 		codage JavaScript: Antonio de Sousa Dias
//  		CICM - MSH Paris Nord / Universite Paris 8
//
// =============================================================
//	notes: 
// last rev 09/01/2007  17:00
// This is one of the ways Max can create messages containing 
// double quote symbols
// =============================================================
//                inlets and outlets 
// =============================================================
inlets = 1 ;
outlets = 1 ;
setinletassist(0,"messages");
setoutletassist(0,"messages to thispatcher object");

// =============================================================
//                global variables and arrays 
// =============================================================


// =============================================================
//                Functions start here 
// =============================================================
// The next functions  construct the string messages that Max will send to
// VirChor. You should notice the absence of space characters in each string
// Max will create them; otherwise double quotes will start to appear everywhere

// =============================================================
function Loop( ) {
// =============================================================
var coef1 = arguments[ 0 ];
var coef2 = arguments[ 1 ];
var crNum = arguments[ 2 ];
var messNum = arguments[ 3 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_node_attribute_value","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<subdivision", "coefLoop1","=",coef1,"coefLoop2", "=", coef2, "/>");
aMessageBody[ 2 ] = new Array( "</set_node_attribute_value>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#subdivision", "surface", "crystal", crNum, "\"/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);
}
// =============================================================
function MB( ) {
// =============================================================
var coefMb1 = arguments[ 0 ];
var coefMb2 = arguments[ 1 ];
var coefMb3 = arguments[ 2 ];
var crNum = arguments[ 3 ];
var messNum = arguments[ 4 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_node_attribute_value","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<subdivision", "coefMB1","=",coefMb1,"coefMB2", "=", coefMb2, "coefMB3", "=", coefMb3,"/>");
aMessageBody[ 2 ] = new Array( "</set_node_attribute_value>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#subdivision", "surface", "crystal", crNum, "\"/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);
}

// =============================================================
function echo( ) {
// =============================================================
var dEcho = arguments[ 0 ];
var messNum = arguments[ 1 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_environment_attribute_value","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<display", "echo","=",dEcho,"/>");
aMessageBody[ 2 ] = new Array( "</set_environment_attribute_value>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#configuration", "node*\"","/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);

}
// =============================================================
function step( ) {
// =============================================================
var dStep = arguments[ 0 ];
var messNum = arguments[ 1 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_environment_attribute_value","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<frame_rate", "time_step_expansion","=",dStep,"/>");
aMessageBody[ 2 ] = new Array( "</set_environment_attribute_value>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#configuration", "node*\"","/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);
}
// =============================================================
function ambient( ) {
// =============================================================
var ambR = arguments[ 0 ];
var ambG = arguments[ 1 ];
var ambB = arguments[ 2 ];
var crNum = arguments[ 3 ];
var messNum = arguments[ 4 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_material_attribute_value","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<ambient", "r","=",ambR,"g", "=", ambG, "b", "=", ambB,"/>");
aMessageBody[ 2 ] = new Array( "</set_material_attribute_value>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#subdivision", "surface", "crystal", crNum, "\"/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);

}
// =============================================================
function distance( ) {
// =============================================================
var dDistance = arguments[ 0 ];
var messNum = arguments[ 1 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_node_attribute_value","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<transformation", "x","=",dDistance,"/>");
aMessageBody[ 2 ] = new Array( "</set_node_attribute_value>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#translation", "camera", "#1*\"","/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);

}
// =============================================================
function weights( ) {
// =============================================================
var w1 = arguments[ 0 ];
var w2 = arguments[ 1 ];
var w3 = arguments[ 2 ];
var messNum = arguments[ 3 ];
var aMessageHead = new Array("send", "sound", messNum);
var aMessageBody = new Array();
aMessageBody[ 0 ] = new Array( "<set_schedule_new_target","operator=", "\"=\"","/>");
aMessageBody[ 1 ] = new Array( "<weights", "dim=3>",w1, w2, w3,"</weights>");
aMessageBody[ 2 ] = new Array( "</set_schedule_new_target>");
aMessageBody[ 3 ] = new Array( "<target","type=","\"multiple_nodes\"", "value=", "\"#interpolator", "crystals\"", "/>");
outlet( 0,  aMessageHead, aMessageBody[ 0 ], aMessageBody[ 1 ], aMessageBody[ 2 ], aMessageBody[ 3 ]);
}

// =============================================================
